// Fig. 6.5: time1.h
// Declaration of class Time.
// Member functions are defined in time1.cpp

// prevent multiple inclusions of header file
#ifndef TIME1_H
#define TIME1_H

// Time abstract data type definition
class Time {
	friend int timcmp(Time &, Time &); //friend function to compare times

public:
   Time();                        // constructor
   void setTime( int, int, int ); // set hour, minute, second
   void printUniversal();         // print universal-time format
   void printStandard();          // print standard-time format
   void printResult(int);         // Print the result after the comparision
                                  // THIS SHOULD NOT BE A MEMBER FUNCTION 

private:
   int hour;     // 0 - 23 (24-hour clock format)
   int minute;   // 0 - 59
   int second;   // 0 - 59

}; // end class Time

#endif

/**************************************************************************
 * (C) Copyright 1992-2002 by Deitel & Associates, Inc. and Prentice      *
 * Hall. All Rights Reserved.                                             *
 *                                                                        *
 * DISCLAIMER: The authors and publisher of this book have used their     *
 * best efforts in preparing the book. These efforts include the          *
 * development, research, and testing of the theories and programs        *
 * to determine their effectiveness. The authors and publisher make       *
 * no warranty of any kind, expressed or implied, with regard to these    *
 * programs or to the documentation contained in these books. The authors *
 * and publisher shall not be liable in any event for incidental or       *
 * consequential damages in connection with, or arising out of, the       *
 * furnishing, performance, or use of these programs.                     *
 *************************************************************************/

// Modified by Keerthi Kanth Reddy Sathi
// Fig. 6.6: time1.cpp
// Member-function definitions for class Time.
#include <iostream>

using std::cout;

#include <iomanip>

using std::setfill;
using std::setw;

// include definition of class Time from time1.h
#include "time1.h" 

// Time constructor initializes each data member to zero.
// Ensures all Time objects start in a consistent state.
Time::Time() 
{ 
   hour = minute = second = 0; 

} // end Time constructor

//Function to compare times

int timcmp(Time &t1, Time &t2)
{
	if(t1.hour > t2.hour)
		return 1;
		else if(t1.hour < t2.hour)
			return -1;
	else 
	{
		if(t1.minute > t2.minute)
			return 1;
		else if(t1.minute < t2.minute)
			return -1;
	else
	{
		if(t1.second > t2.second)
			return 1;
		else if(t1.second < t2.second)
 			return -1;
    else
		return 0;
	}
	}
}

// Set new Time value using universal time. Perform validity
// checks on the data values. Set invalid values to zero.
void Time::setTime( int h, int m, int s )
{
   hour = ( h >= 0 && h < 24 ) ? h : 0;
   minute = ( m >= 0 && m < 60 ) ? m : 0;
   second = ( s >= 0 && s < 60 ) ? s : 0;

} // end function setTime

// print Time in universal format
void Time::printUniversal()
{
   cout << setfill( '0' ) << setw( 2 ) << hour << ":"
        << setw( 2 ) << minute << ":"
        << setw( 2 ) << second;

} // end function printUniversal

// print Time in standard format
void Time::printStandard()
{
   cout << ( ( hour == 0 || hour == 12 ) ? 12 : hour % 12 )
        << ":" << setfill( '0' ) << setw( 2 ) << minute
        << ":" << setw( 2 ) << second 
        << ( hour < 12 ? " AM" : " PM" );

} // end function printStandard

//Function to display the results after the comparisions
void Time::printResult(int x)
{
	if ( x == 1)
		cout << "\n\n"<<x<<"\nt1 is greater than t2\n";
	else if( x == 0)
	    cout << "\n\n"<<x<<"\nt1 is equal to t2\n";
	else
	    cout << "\n\n"<<x<<"\nt1 is smaller than t2\n";
}
/**************************************************************************
 * (C) Copyright 1992-2002 by Deitel & Associates, Inc. and Prentice      *
 * Hall. All Rights Reserved.                                             *
 *                                                                        *
 * DISCLAIMER: The authors and publisher of this book have used their     *
 * best efforts in preparing the book. These efforts include the          *
 * development, research, and testing of the theories and programs        *
 * to determine their effectiveness. The authors and publisher make       *
 * no warranty of any kind, expressed or implied, with regard to these    *
 * programs or to the documentation contained in these books. The authors *
 * and publisher shall not be liable in any event for incidental or       *
 * consequential damages in connection with, or arising out of, the       *
 * furnishing, performance, or use of these programs.                     *
 *************************************************************************/

// Modified by Keerthi Kanth Reddy Sathi
// CS 202 HW #3 Problem 1
// Fig. 6.7: fig06_07.cpp
// Program to test class Time.
// NOTE: This file must be compiled with time1.cpp.
#include <iostream>

using std::cout;
using std::endl;

// include definition of class Time from time1.h
#include "time1.h"

int main()
{
   Time t1,t2;  // instantiate objects of class Time

   //test case to show t1 == t2
   t1.setTime( 13, 27, 6 );   // change time
   // output Time object t's new values
   cout << "t1(Universal time) : ";
   t1.printUniversal();   // 13:27:06
   cout << "\nt1(Standard time)  :  ";
   t1.printStandard();    // 1:27:06 PM

   t2.setTime( 13, 27, 6 );   // change time
   // output Time object t's new values
   cout << "\n\nt2(Universal time) : ";
   t2.printUniversal();   // 13:27:06
   cout << "\nt2(Standard time)  :  ";
   t2.printStandard();    // 1:27:06 PM

   int x = timcmp(t1,t2);

   t1.printResult(x); //display the result

   //Test case to show t1 > t2
  
   t1.setTime( 19, 45, 50 );   // change time
   // output Time object t's new values
   cout << "\n\nt1(Universal time) : ";
   t1.printUniversal();   // 19:45:50
   cout << "\nt1(Standard time)  : ";
   t1.printStandard();    // 7:45:50 PM
   
   cout << "\n\nt2(Universal time) : ";
   t2.printUniversal();   // 13:27:06
   cout << "\nt2(Standard time)  :  ";
   t2.printStandard();    // 1:27:06 PM

   x = timcmp(t1,t2);

   t1.printResult(x); //Display the result

  //Test case to show t1 < t2
   t1.setTime( 13,27,6 );   // change time
   // output Time object t's new values
   cout << "\n\nt1(Universal time) : ";
   t1.printUniversal();   // 19:45:50
   cout << "\nt1(Standard time)  :  ";
   t1.printStandard();    // 7:45:50 PM
   
   t2.setTime( 19,45,50 );   // change time
   // output Time object t's new values
   cout << "\n\nt2(Universal time) : ";
   t2.printUniversal();   // 13:27:06
   cout << "\nt2(Standard time)  :  ";
   t2.printStandard();    // 1:27:06 PM

   x = timcmp(t1,t2);
   t1.printResult(x); //Display the result
   return 0; 

} // end main

/**************************************************************************
 * (C) Copyright 1992-2002 by Deitel & Associates, Inc. and Prentice      *
 * Hall. All Rights Reserved.                                             *
 *                                                                        *
 * DISCLAIMER: The authors and publisher of this book have used their     *
 * best efforts in preparing the book. These efforts include the          *
 * development, research, and testing of the theories and programs        *
 * to determine their effectiveness. The authors and publisher make       *
 * no warranty of any kind, expressed or implied, with regard to these    *
 * programs or to the documentation contained in these books. The authors *
 * and publisher shall not be liable in any event for incidental or       *
 * consequential damages in connection with, or arising out of, the       *
 * furnishing, performance, or use of these programs.                     *
 *************************************************************************/

/*OUTPUT:

t1(Universal time) : 13:27:06
t1(Standard time)  :  1:27:06 PM

t2(Universal time) : 13:27:06
t2(Standard time)  :  1:27:06 PM

0
t1 is equal to t2


t1(Universal time) : 19:45:50
t1(Standard time)  : 7:45:50 PM

t2(Universal time) : 13:27:06
t2(Standard time)  :  1:27:06 PM

1
t1 is greater than t2


t1(Universal time) : 13:27:06
t1(Standard time)  :  1:27:06 PM

t2(Universal time) : 19:45:50
t2(Standard time)  :  7:45:50 PM

-1
t1 is smaller than t2
Press any key to continue

*/

